// #autoload
// #name = FreeHUDs
// #version = 1.7
// #date = May 4, 2003
// #author = Paul Tousignant
// #warrior = UberGuy (FT)
// #email = uberguy@tribes2.org
// #web = http://uberguy.tribes2.org
// #description = Creates independant, hudMover compatible Compass and life/energy bars
// #status = Release
// #category = UberGuy's Scripts
// #credit = LouCypher - added vertical damage and energy/heat 20030504

if(!isObject(uberGUI)) {
    new ScriptObject(uberGUI) { class = uberGUI; };
}

function uberGUI::setDefaults(%this) {

	CompassVisible.setValue(true);
	CompassFancy.setValue(true);
	CompassRing.setValue(true);
	CompassXpar.setValue(1.0);
	CompassClock.setValue(true);
	CompassRadar.setValue(true);

	ClockVisible.setValue(true);
	ClockXpar.setValue(1.0);
	ClockOpaque.setValue(false);

	RadarVisible.setValue(true);
	RadarRing.setValue(true);
	RadarXpar.setValue(1.0);

	horzHealthVisible.setValue(true);
	horzHealthXpar.setValue(1.0);
	horzHealthFrame.setValue(true);
	vertHealthVisible.setValue(true);
	vertHealthXpar.setValue(1.0);
	vertHealthFrame.setValue(true);

	horzEnergyVisible.setValue(true);
	horzEnergyXpar.setValue(1.0);
	horzEnergyFrame.setValue(true);
	vertEnergyVisible.setValue(true);
	vertEnergyXpar.setValue(1.0);
	vertEnergyFrame.setValue(true);
}

function uberGUI::loadPrefs(%this, %force) {

	if (!$uberPref::loaded || %force) {
		exec("prefs/uberPrefs.cs");
		$uberPref::loaded = 1;
	}

	CompassVisible.setValue($uberPref::freeHUDs::show_["uberCompassFrame"]);
	eval(CompassVisible.command);
	CompassXpar.setValue($uberPref::freeHUDs::opacity_["uberCompassFrame"]);
	eval(CompassXpar.command);
	CompassRing.setValue($uberPref::freeHUDs::show_["uberCompassRing"]);
	eval(CompassRing.command);
	CompassFancy.setValue($uberPref::freeHUDs::show_["uberCompassImage"]);
	eval(CompassFancy.command);
	CompassClock.setValue($uberPref::freeHUDs::show_["uberClock"]);
	eval(CompassClock.command);
	CompassRadar.setValue($uberPref::freeHUDs::show_["uberSensorGrp"]);
	eval(CompassRadar.command);

	ClockVisible.setValue($uberPref::freeHUDs::show_["uberClockFrame"]);
	eval(ClockVisible.command);
	ClockXpar.setValue($uberPref::freeHUDs::opacity_["uberClockFrame"]);
	eval(ClockXpar.command);
	ClockOpaque.setValue($uberPref::freeHUDs::transparentClock);
	eval(ClockOpaque.command);

	RadarVisible.setValue($uberPref::freeHUDs::show_["uberSensorFrame"]);
	eval(RadarVisible.command);
	RadarXpar.setValue($uberPref::freeHUDs::opacity_["uberSensorFrame"]);
	eval(RadarXpar.command);
	RadarRing.setValue($uberPref::freeHUDs::show_["uberSensorRing"]);
	eval(RadarRing.command);

	horzHealthVisible.setValue($uberPref::freeHUDs::show_["horzDamageFrame"]);
	eval(horzHealthVisible.command);
	horzHealthXpar.setValue($uberPref::freeHUDs::opacity_["horzDamageFrame"]);
	eval(horzHealthXpar.command);
	horzHealthFrame.setValue($uberPref::freeHUDs::show_["horzDamageBitmap"]);
	eval(horzHealthFrame.command);
	vertHealthVisible.setValue($uberPref::freeHUDs::show_["vertDamageFrame"]);
	eval(vertHealthVisible.command);
	vertHealthXpar.setValue($uberPref::freeHUDs::opacity_["vertDamageFrame"]);
	eval(vertHealthXpar.command);
	vertHealthFrame.setValue($uberPref::freeHUDs::show_["vertDamageBitmap"]);
	eval(vertHealthFrame.command);

	
	horzEnergyVisible.setValue($uberPref::freeHUDs::show_["horzEnergyFrame"]);
	eval(horzEnergyVisible.command);
	horzEnergyXpar.setValue($uberPref::freeHUDs::opacity_["horzEnergyFrame"]);
	eval(horzEnergyXpar.command);
	horzEnergyFrame.setValue($uberPref::freeHUDs::show_["horzEnergyBitmap"]);
	eval(horzEnergyFrame.command);
	vertEnergyVisible.setValue($uberPref::freeHUDs::show_["vertEnergyFrame"]);
	eval(vertEnergyVisible.command);
	vertEnergyXpar.setValue($uberPref::freeHUDs::opacity_["vertEnergyFrame"]);
	eval(vertEnergyXpar.command);
	vertEnergyFrame.setValue($uberPref::freeHUDs::show_["vertEnergyBitmap"]);
	eval(vertEnergyFrame.command);
}

function uberGUI::savePrefs(%this) {

	export("$uberPref::*", "prefs/uberPrefs.cs", false);
}

function uberGUI::activate(%this) {

	activatePackage(uberGuiPkg);
}

function uberGUI_toggleFHpane(%val) {

	if (%val) {
		if (freeHUDsPane.displayed) Canvas.popDialog(freeHUDsPane);
		else Canvas.pushDialog(freeHUDsPane);
		freeHUDsPane.displayed = ! freeHUDsPane.displayed;
	}
}

// New GuiControl methods =====================================================

function GuiControl::setAllOpacity(%this, %val, %child) {

	//Record preference of root object
	if (!%child) $uberPref::freeHUDs::opacity_[%this] = %val;

	//Set opacity
	if (%this.opacity !$= "") {
		if (%this.baseOpacity $= "") %this.baseOpacity = %this.opacity;
		%this.opacity = (%this.baseOpacity + 0) * %val;
	}

	//Recursively set opacity of all child objects
	for(%i=0; %i<%this.getCount(); %i++) {
		%this.getObject(%i).setAllOpacity(%val, true);
	}
}

// Try to show the object based on it's last visiblity setting call
// May be overriden by prefs (see setVisible())
function GuiControl::refreshVisible(%this) {

	if (%this.desiredVis $= "") %this.desiredVis = %this.visible;
	%this.setVisible(%this.desiredVis);
}

function uberClockFrame::toggleProfile(%this) {

	%this.profile =
		$uberPref::freeHUDs::transparentClock ? GuiDefaultProfile : GuiChatBackProfile;
	playGui.remove(%this);
	playGui.add(%this);
}

// Function Overrides =========================================================

package uberGuiPkg {

	// Allow prefs for hiding objects to override the parameter sent
	function GuiControl::setVisible(%this, %val) {

		if ($uberPref::freeHUDs::show_[%this] !$= "") {
			%this.desiredVis = %val;
			parent::setVisible(%this,$uberPref::freeHUDs::show_[%this] && %val);
		}
		else
			parent::setVisible(%this,%val);
	}

	// Keep game from re-adding the Sensor back to the original compass cluster
	function hudClusterBack::add(%this, %object) {

		if (%object $= SensorHud) return;
		parent::add(%this, %object);
	}

	// Toggle the FreeHUDs with the rest
	function clientCmdTogglePlayHuds(%val) {

		uberClockFrame.setVisible(%val);
		horzDamageFrame.setVisible(%val);
		vertDamageFrame.setVisible(%val);
		horzEnergyFrame.setVisible(%val);
		vertEnergyFrame.setVisible(%val);
		uberSensorFrame.setVisible(%val);
		uberCompassFrame.setVisible(%val);
		parent::clientCmdTogglePlayHuds(%val);
	}

	// Keep game from re-adding the clock or compass cluster back to the playGui
	function playGui::add(%this, %object) {

		if (%object $= clockHud || %object $=hudClusterBack) return;
		parent::add(%this, %object);
	}

	// Update my new sensor HUD with the old one
	function SensorHud::update(%this) {

		uberSensor.setVisible(%this.ping || %this.jam);

		if(%this.jam) uberSensor.color = %this.jamColor;
		else uberSensor.color = %this.pingColor;
		parent::update(%this);
	}

	// Create and initialize everything
//	function LoadingGui::onWake(%this) {
	function playGui::onWake(%this) {

		parent::onWake(%this);
		if (!isObject(freeHUDsPane)) {
			exec("scripts/UberGuy/freeHUDs.gui");
			uberGUI.createElements();
			uberGUI.setDefaults();
			uberGUI.loadPrefs(true);
		}
	}

	// Keep my clocks in synch
	function clientCmdSyncHudClock(%time) {
		echo("TICK");
		uberClock.setTime(%time);
		uberClock2.setTime(%time);
		parent::clientCmdSyncHudClock(%time);
	}

	function setSystemClock(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
		echo("TOCK");
		$Hud::TimeLimit = detag(%a1);
		%timeLeftMS = detag(%a2);
		uberClock.setTime(%time = %timeLeftMS / (60 * 1000));
		uberClock2.setTime(%time);
		parent::setSystemClock(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	}

	function OptionsDlg::onWake(%this) {

		if (!uberGUI.options) {
			$RemapName[$RemapCount] = "FreeHUDs Options";
			$RemapCmd[$RemapCount]  = "uberGUI_toggleFHpane";
			$RemapCount++;
			uberGUI.options = true;
		}
		parent::onWake(%this);
	}
};

// Main GUI Construction Area (LONG) ==========================================

function uberGUI::createElements(%this) {

	if (!isObject(uberCompassFrame)) {
		exec("scripts/UberGuy/uCF.obj");	// uberCompassFrame
		exec("scripts/UberGuy/uSF.obj");	// uberSensorFrame
		exec("scripts/UberGuy/hEF.obj");	// horzEnergyFrame
		exec("scripts/UberGuy/vEF.obj");	// vertEnergyFrame
		exec("scripts/UberGuy/hDF.obj");	// horzDamageFrame
		exec("scripts/UberGuy/vDF.obj");	// vertDamageFrame
		exec("scripts/UberGuy/uCkF.obj");	// uberClockFrame
		uberSensorGrp.add(SensorHud);
		sensorHud.position = "0 0";
	}

	if (playGui.isMember(clockHud)) playGui.remove(clockHud);
	if (playGui.isMember(hudClusterBack)) playGui.remove(hudClusterBack);

	if (!playGui.isMember(uberClockFrame))	playGui.add(uberClockFrame);
	if (!playGui.isMember(uberSensorFrame))	playGui.add(uberSensorFrame);
	if (!playGui.isMember(horzDamageFrame))	playGui.add(horzDamageFrame);
	if (!playGui.isMember(vertDamageFrame))	playGui.add(vertDamageFrame);
	if (!playGui.isMember(horzEnergyFrame))	playGui.add(horzEnergyFrame);
	if (!playGui.isMember(vertEnergyFrame))	playGui.add(vertEnergyFrame);
	if (!playGui.isMember(uberCompassFrame)) playGui.add(uberCompassFrame);

	// Add to hudMover
	if(isObject(HM) && isObject(HudMover)) {
		hudmover::addhud(uberClockFrame,"Free Clock");
		hudmover::addhud(uberSensorFrame,"Free Sensor");
		hudmover::addhud(uberCompassFrame,"Free Compass");
		hudmover::addhud(horzDamageFrame,"Free HealthBar (Horizontal)");
		hudmover::addhud(vertDamageFrame,"Free HealthBar (Vertical)");
		hudmover::addhud(horzEnergyFrame,"Free EnergyBar (Horizontal)");
		hudmover::addhud(vertEnergyFrame,"Free EnergyBar (Vertical)");
	}
}

uberGui.activate();